/* Macros for print function definitions */

#ifdef __LINUX__

#define DECLARE_PRINT_MM(REG, FORMAT) \
    .global print_mm ## REG ## _ ## FORMAT ??/n \
print_mm ## REG ## _ ## FORMAT : ??/n \
	??/t pushal ??/n \
	??/t pushfl ??/n \
	??/t movl %esp, %ebp ??/n \
	??/t subl $8, %esp ??/n \
	??/t movl $ ## REG, (%esp) ??/n \
	??/t call print_mm ## _ ## FORMAT  ??/n \
	??/t mov %ebp, %esp ??/n\
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n
	
#endif

#ifdef __CYGWIN__

#define DECLARE_PRINT_MM(REG, FORMAT) \
    .global _print_mm ## REG ## _ ## FORMAT ??/n \
_print_mm ## REG ## _ ## FORMAT : ??/n \
	??/t pushal ??/n \
	??/t pushfl ??/n \
	??/t movl %esp, %ebp ??/n \
	??/t subl $8, %esp ??/n \
	??/t movl $ ## REG, (%esp) ??/n \
	??/t call _print_mm ## _ ## FORMAT  ??/n \
	??/t mov %ebp, %esp ??/n\
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n
	
#endif

#ifdef __LINUX__

#define DECLARE_PRINT_XMM(REG) \
    .global print_xmm ## REG  ??/n \
print_xmm ## REG: ??/n \
	??/t pushal ??/n\
	??/t pushfl ??/n\
	??/t movl %esp, %ebp ??/n\
	??/t subl $8, %esp ??/n\
	??/t movl $ ## REG, (%esp) ??/n \
	??/t call print_xmm ??/n \
	??/t movl %ebp, %esp ??/n\
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n

#endif

#ifdef __CYGWIN__

#define DECLARE_PRINT_XMM(REG) \
    .global _print_xmm ## REG  ??/n \
_print_xmm ## REG: ??/n \
	??/t pushal ??/n\
	??/t pushfl ??/n\
	??/t movl %esp, %ebp ??/n\
	??/t subl $8, %esp ??/n\
	??/t movl $ ## REG, (%esp) ??/n \
	??/t call _print_xmm ??/n \
	??/t movl %ebp, %esp ??/n\
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n

#endif


#ifdef __LINUX__

#define DECLARE_PRINT_MM_REGS(FORMAT) \
    .global print_mm_regs ## _ ## FORMAT ??/n \
print_mm_regs ## _ ## FORMAT : ??/n \
	??/t pushal ??/n\
	??/t pushfl ??/n\
	??/t call cprint_mm_regs_ ## FORMAT  ??/n \
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n

#endif

#ifdef __CYGWIN__

#define DECLARE_PRINT_MM_REGS(FORMAT) \
    .global _print_mm_regs ## _ ## FORMAT ??/n \
_print_mm_regs ## _ ## FORMAT : ??/n \
	??/t pushal ??/n\
	??/t pushfl ??/n\
	??/t call _cprint_mm_regs_ ## FORMAT  ??/n \
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n

#endif

#ifdef __LINUX__

#define DECLARE_PRINT_XMM_REGS \
    .global print_xmm_regs ??/n \
print_xmm_regs : ??/n \
	??/t pushal ??/n\
	??/t pushfl ??/n\
	??/t call cprint_xmm_regs  ??/n \
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n

#endif	

#ifdef __CYGWIN__

#define DECLARE_PRINT_XMM_REGS \
    .global _print_xmm_regs ??/n \
_print_xmm_regs : ??/n \
	??/t pushal ??/n\
	??/t pushfl ??/n\
	??/t call _cprint_xmm_regs  ??/n \
	??/t popfl ??/n\
	??/t popal ??/n\
	??/t ret ??/n\
	??/n

#endif	

	.file "stubs.s" 
	.att_syntax
	.text	   
	


/* Print function declarations.

   Following functions are declared: 
   
   	print_mm0_pb
   	print_mm1_pb 
   	print_mm2_pb 
   	print_mm3_pb 
   	print_mm4_pb 
   	print_mm5_pb 
   	print_mm6_pb 
   	print_mm7_pb 

*/
DECLARE_PRINT_MM(0,pb)  
DECLARE_PRINT_MM(1,pb)
DECLARE_PRINT_MM(2,pb)
DECLARE_PRINT_MM(3,pb)
DECLARE_PRINT_MM(4,pb)
DECLARE_PRINT_MM(5,pb)
DECLARE_PRINT_MM(6,pb)
DECLARE_PRINT_MM(7,pb)

/*
   	print_mm0_pw 
   	print_mm1_pw 
   	print_mm2_pw 
   	print_mm3_pw 
   	print_mm4_pw 
   	print_mm5_pw 
   	print_mm6_pw 
   	print_mm7_pw 

*/

DECLARE_PRINT_MM(0,pw)
DECLARE_PRINT_MM(1,pw)
DECLARE_PRINT_MM(2,pw)
DECLARE_PRINT_MM(3,pw)
DECLARE_PRINT_MM(4,pw)
DECLARE_PRINT_MM(5,pw)
DECLARE_PRINT_MM(6,pw)
DECLARE_PRINT_MM(7,pw)

/*
   	print_mm0_pd 
   	print_mm1_pd 
   	print_mm2_pd 
   	print_mm3_pd 
   	print_mm4_pd 
   	print_mm5_pd 
   	print_mm6_pd 
   	print_mm7_pd 

*/

DECLARE_PRINT_MM(0,pd)
DECLARE_PRINT_MM(1,pd)
DECLARE_PRINT_MM(2,pd)
DECLARE_PRINT_MM(3,pd)
DECLARE_PRINT_MM(4,pd)
DECLARE_PRINT_MM(5,pd)
DECLARE_PRINT_MM(6,pd)
DECLARE_PRINT_MM(7,pd)

/*
   	print_mm0_pq 
   	print_mm1_pq 
   	print_mm2_pq 
   	print_mm3_pq 
   	print_mm4_pq 
   	print_mm5_pq 
   	print_mm6_pq 
   	print_mm7_pq 

*/
 
DECLARE_PRINT_MM(0,pq)
DECLARE_PRINT_MM(1,pq)
DECLARE_PRINT_MM(2,pq)
DECLARE_PRINT_MM(3,pq)
DECLARE_PRINT_MM(4,pq)
DECLARE_PRINT_MM(5,pq)
DECLARE_PRINT_MM(6,pq)
DECLARE_PRINT_MM(7,pq)

/*
   	print_mm0_fp 
   	print_mm1_fp 
   	print_mm2_fp 
   	print_mm3_fp 
   	print_mm4_fp 
   	print_mm5_fp 
   	print_mm6_fp 
   	print_mm7_fp 

*/
 
DECLARE_PRINT_MM(0,fp)
DECLARE_PRINT_MM(1,fp)
DECLARE_PRINT_MM(2,fp)
DECLARE_PRINT_MM(3,fp)
DECLARE_PRINT_MM(4,fp)
DECLARE_PRINT_MM(5,fp)
DECLARE_PRINT_MM(6,fp)
DECLARE_PRINT_MM(7,fp)

/*
   	print_xmm0 
   	print_xmm1 
   	print_xmm2 
   	print_xmm3 
   	print_xmm4 
   	print_xmm5 
   	print_xmm6 
   	print_xmm7 

*/

DECLARE_PRINT_XMM(0)
DECLARE_PRINT_XMM(1)
DECLARE_PRINT_XMM(2)
DECLARE_PRINT_XMM(3)
DECLARE_PRINT_XMM(4)
DECLARE_PRINT_XMM(5)
DECLARE_PRINT_XMM(6)
DECLARE_PRINT_XMM(7)

DECLARE_PRINT_MM_REGS(pb)
DECLARE_PRINT_MM_REGS(pw)
DECLARE_PRINT_MM_REGS(pd)
DECLARE_PRINT_MM_REGS(pq)
DECLARE_PRINT_MM_REGS(fp)
DECLARE_PRINT_XMM_REGS
	
	


