;**************************************************************************
;  
;  Funkce void student() v asembleru (verze pro NASM)
;  --------------------------------------------------
;   
;  Tento zdrojovy kod obsahuje nezbytnou
;  cast implementace funkce student(), ktera bude 
;  prilinkovana k main.c. V casti "... zde doplnte instrukce ..."
;  muze student dopsat jakekoliv MMX, SSE, SSE2, SSE3 instrukce podle 
;  zadaneho ukolu. 
;      
;  *** Ladici funkce pro MMX, SSE a 3DNow! ***
;  
;  Zobrazeni MMX registru (MMX, 3DNow!):
 
	EXTERN print_mm_regs_pb
	EXTERN print_mm_regs_pw
	EXTERN print_mm_regs_pd
	EXTERN print_mm_regs_pq
	EXTERN print_mm_regs_fp
     
;  Funkce vytisknou vsechny MMX registry ve formatu packet byte(pb), packet
;  word (pw), packet double word (pd), packet quad word (pq) a single-precision
;  FP (fp). Vsechny funkce jsou bez parametru. Funkce _print_mm_regs_fp ma smysl 
;  pouze pro 3DNow!. Volani z asembleru napr. call _print_mm_regs_pd. Format 
;  vystupu (hexadecimalne, dekadicky se znamenkem a bez znamenka) je mozno 
;  ovlivnit parametrem spousteneho programu. Napr. ./main -cl -x zajisti
;  vystup v sestnactkove soustave. 
;   
;  Zobrazeni jednoho MMX registru:
;  
;  Format packet byte (pb):
;
	EXTERN print_mm0_pb
	EXTERN print_mm1_pb
	EXTERN print_mm2_pb
	EXTERN print_mm3_pb
	EXTERN print_mm4_pb
	EXTERN print_mm5_pb
	EXTERN print_mm6_pb
	EXTERN print_mm7_pb
;	
;  Format packet word (pw):
;
	EXTERN print_mm0_pw
	EXTERN print_mm1_pw
	EXTERN print_mm2_pw
	EXTERN print_mm3_pw
	EXTERN print_mm4_pw
	EXTERN print_mm5_pw
	EXTERN print_mm6_pw
	EXTERN print_mm7_pw
;	
;  Format packet dword (pd):
;
	EXTERN print_mm0_pd
	EXTERN print_mm1_pd
	EXTERN print_mm2_pd
	EXTERN print_mm3_pd
	EXTERN print_mm4_pd
	EXTERN print_mm5_pd
	EXTERN print_mm6_pd
	EXTERN print_mm7_pd
;	
;  Format packet qword (pq):
;
	EXTERN print_mm0_pq
	EXTERN print_mm1_pq
	EXTERN print_mm2_pq
	EXTERN print_mm3_pq
	EXTERN print_mm4_pq
	EXTERN print_mm5_pq
	EXTERN print_mm6_pq
	EXTERN print_mm7_pq
;
;
;  Zobrazeni XMM registru (jen SSE, SSE2, SSE3)	
;
	EXTERN print_xmm_regs
;  
;  Tato funkce vytiskne vsechny XMM registry v single-precision FP formatu. 
;  Funkce nema zadne parametry.
;
;  Zobrazeni jednoho XMM registru
;
	EXTERN print_xmm0
	EXTERN print_xmm1
	EXTERN print_xmm2
	EXTERN print_xmm3
	EXTERN print_xmm4
	EXTERN print_xmm5
	EXTERN print_xmm6
	EXTERN print_xmm7
;  
;  Tato funkce vytiskne jeden XMM registr v single-precision FP formatu. 
;  Funkce nema zadne parametry. Priklad volani z asembleru call _print_xmm0.
;  
;  *** Graficke funkce ***
;  
;  Makro  LOAD_RGB_IMAGE fn, w, h, im
;  
;  Toto makro nahraje obrazek ze souboru fn. Velikost obrazku je urcena 
;  velikosti obrazku v souboru. Velikost se uklada do promennych w a h typu
;  int. Nahrany obrazek se ulozi po radcich do pole im v RGB formatu 00bbggrr
;  (32 bitu na pixel). Velikost pole im musi byt dostatecna
;  pro ulozeni celeho obrazku (nekontroluje se). Pokud je parametr im = 0 (null),
;  pak se naplni pouze promenne w, h. To se da vyuzit ke zjisteni velikosti 
;  obrazku a naslednou kontrolu nebo alokaci pole. 
;  
;  Priklad pouziti:
;  
;    		SEGMENT .data 
;
; width:	DD 0
; height: 	DD 0
;
; image:	RESD 100*100	
;        
;		SEGMENT .text
;		...
;		LOAD_RGB_IMAGE num, width, height, image
;		...
;	 
;        
;  Makro  LOAD_GRAY_IMAGE fn, w, h, im
;  
;  Toto makro nahraje obrazek ze souboru fn. Velikost obrazku je urcena 
;  velikosti obrazku v souboru. Velikost se uklada do promennych w a h typu
;  int. Nahrany obrazek se ulozi po radcich do pole im ve formatu 8 bitu/pixel 
;  (256 urovni sedi). Pozor ! obrazek v souboru muze byt pouze barevny (RGB Truecolor). 
;  Velikost pole im musi byt dostatecna pro ulozeni celeho obrazku (nekontroluje se).
;  Pokud je parametr im = 0 (null), pak se naplni pouze promenne w, h. 
;  To se da vyuzit ke zjisteni velikosti obrazku a naslednou kontrolu nebo alokaci pole.
;
;  Priklad pouziti:
;  
;    		SEGMENT .data  
;
; width:	DD 0
; height: 	DD 0
;
; image:	RESB 100*100	
;        
;		SEGMENT .text
;		...
;		LOAD_GRAY_IMAGE num, width, height, image
;		...
;
;  		Makro SHOW_RGB_IMAGE num, w, h, im      	
;   
;********************************************************************************
;    
	BITS 32      
;	
;	Makra 
;
	EXTERN load_rgb_image
	EXTERN load_gray_image
	EXTERN show_rgb_image
	EXTERN show_gray_image
	
;       LOAD_RGB_IMAGE fn, w, h, im
%macro  LOAD_RGB_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov dword [esp+0x4], %2
	mov dword [esp+0x8], %3
	mov dword [esp+0xC], %4
	call	load_rgb_image 
%endmacro

;	LOAD_GRAY_IMAGE fn, w, h, im
%macro	LOAD_GRAY_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov dword [esp+0x4], %2
	mov dword [esp+0x8], %3
	mov dword [esp+0xC], %4
	call	load_gray_image 
%endmacro

;	SHOW_RGB_IMAGE num, w, h, im
%macro 	SHOW_RGB_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov eax, dword [%2]
	mov dword [esp+0x4], eax
	mov eax, dword [%3]
	mov dword [esp+0x8], eax
	mov dword [esp+0xc], %4
	call	show_rgb_image
%endmacro

;	SHOW_GRAY_IMAGE num, w, h, im
%macro 	SHOW_GRAY_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov eax, dword [%2]
	mov dword [esp+0x4], eax
	mov eax, dword [%3]
	mov dword [esp+0x8], eax
	mov dword [esp+0xc], %4
	call	show_gray_image
%endmacro
	
;********************************************************************************
;
;	Inicializovane promenne
;
	SEGMENT .data

fname: DB "foreground.bmp", 0
bname: DB "background.bmp", 0

width:	DD 0
height:	DD 0

keycol: DD 0x00808000, 0x00808000

;	Neinicializovane promenne	
;	
	SEGMENT .bss

%define IMG_X 200
%define IMG_Y 200

; alokace mista na masku a obrazky
fimage:  RESD (IMG_X * IMG_Y)
bimage:  RESD (IMG_X * IMG_Y)
maska:   RESD (IMG_X * IMG_Y)

;
; 	Program
;		
     	SEGMENT .text
;
;	Export funkce student()
;
	GLOBAL student

student: 
 	; Prolog
       	push   ebp
        mov    ebp, esp

        ; Telo funkce
	
	; Nulovani MMX registru 

	pxor mm0, mm0
	pxor mm1, mm1
	pxor mm2, mm2
	pxor mm3, mm3
	pxor mm4, mm4
	pxor mm5, mm5
	pxor mm6, mm6
	pxor mm7, mm7

	; ... zde napiste instrukce ...
	
	; Priklad: 1 
	; (odkomentujte nasledujici 4 radky, prelozte a
	; spustte s parametrem -gr. [./main -gr])
	; 
	 LOAD_RGB_IMAGE fname, width, height, fimage
	 SHOW_RGB_IMAGE 1, width, height, fimage      	
	 LOAD_RGB_IMAGE bname, width, height, bimage
	 SHOW_RGB_IMAGE 2, width, height, bimage      	


	; fimage -- obrazek ze ktereho se vytvori maska 
	mov ecx, (IMG_X*IMG_Y)/2
	mov eax, fimage
	mov ebx, maska
	
	movq mm1, [keycol]

	call print_mm1_pb ; vypis mm0 registru

	masking:
		movq mm0, [eax]
		pcmpeqd mm0, mm1
		movq [ebx], mm0
		add eax, 8
		add ebx, 8
		loop masking

	SHOW_RGB_IMAGE 3, width, height, maska

	mov eax, fimage
	mov ebx, maska 
	mov edx, bimage 

	mov ecx, (IMG_X*IMG_Y)/2

	createpix:
		movq mm0, [ebx]; maska
		movq mm1, mm0
		movq mm2, [eax]; foregroung
		movq mm6, [edx]; background

		; pozadi and maska
		pand mm0, mm6

 		; not maska and foreground
		pandn mm1, mm2

		; (pozadi and maska) or (not maska and foreground)
		por mm0, mm1
		movq [edx], mm0

		add eax, 8
		add ebx, 8
		add edx, 8
	loop createpix

	SHOW_RGB_IMAGE 4, width, height, bimage

;	call print_mm0_pb ; vypis mm0 registru
;	call print_mm1_pb ; vypis mm0 registru
	
	; Epilog
	leave
        ret

;**************************************************************************
